<p>Pogledajmo sada jedan konkretan primjer izvođenja programa. Radimo s računalnim sustavom
    koji je izgrađen od procesora i jednog memorijskog čipa. Struktura takvog sustava u skladu
    je s onom prikazanom na slici 1.</p>

<figure class="mlFigure">
    <img src="@#file#(mpsustav.svg)" alt="Osnovna struktura računala prikazana"><br>
    <figcaption><span class="mlFigKey">Slika 1.</span> Osnovna struktura računala prikazana</figcaption>
</figure>

<p>Program koji će procesor izvesti sastoji se od dohvata okteta podatka koji je zapisan na
    memorijskoj lokaciji 17 (u binarnom zapisu, to je <code>00010001</code>, a podatak će biti
    broj 14 što je u heksadekadskoj notaciji <code>0E</code>) i pohrani u registar
    <code>r0</code>, inkrementu dohvaćene vrijednosti za jedan, i na kraju pohrani te izračunate
    vrijednosti na memorijsku lokaciju 18 (u binarnom zapisu, to je <code>00010010</code>, a
    novi podatak će biti broj 15 što je u heksadekadskoj notaciji <code>0F</code>). Na kraju, izvest
    će instrukciju <code>HALT</code> koja će ga zaustaviti. U assembleru, program bismo zapisali na
    sljedeći način:</p>

<pre>        LDA r0, [17]
        INC r0
        STA [18], r0
        HALT</pre>

<p>Interaktivni prikaz sustava izgrađenog od procesora i memorijskog čipa prikazan je u
    nastavku. Najprije je prikazan sam sustav a ispod i sadržaj radne memorije (RAM-a) čija je
    veličina 256 okteta. U tu memoriju od početka su pohranjene instrukcije procesora a potom (na
    lokaciju 17) i podatak (broj 14). Kod prikaza sustava vidljivo je stanje na podatkovnoj
    i adresnoj sabirnici te u samom procesoru sadržaj registara, zastavica, programskog brojila
    (PC) koje čuva adresu s koje će se dohvatiti instrukcija i drugih relevantnih informacija
    s kojima ćemo se upoznati kroz ovu seriju minilekcija.</p>

<script>
    /*@#page-include#(canvasActRegUtil.js)*/
    /*@#page-include#(wires.js)*/
    /*@#page-include#(cpu-elements.js)*/
    /*@#page-include#(dlsimul.js)*/
    /*@#page-include#(dlsimul-incremental.js)*/
    /*@#page-include#(system1.js)*/
    /*@#page-include#(system1vis.js)*/
    /*@#page-include#(ram-visual.js)*/
</script>

<div style="width: 550px; height: 370px; text-align: center;">
    <canvas id="myCanvas1" width="550" height="370" style="border: 1px dotted black;"></canvas>
</div>

<center><p>Sadržaj memorije po memorijskim lokacijama:</p></center>

<div style="width: 670px; height: 160px; text-align: center;">
    <canvas id="myCanvasRamC" width="670" height="160" style="border: 1px dotted black;"></canvas>
</div>

<script>
    let engine = dlsimul.engine.createEngine();
    let cp = engine.createSignal("/cp", dlsimul.std_logic_1164.valueIndex('U'));
    let res = engine.createSignal("/res", dlsimul.std_logic_1164.valueIndex('U'));

    let system = new cpu_system_1(engine, "", "system", 5, true, res, cp);

    system.circuits[1].setContentWord(0, [1, 0, 0, 0, 0, 1, 0, 0]); // LDA r0, [17]
    system.circuits[1].setContentWord(1, [0, 0, 0, 1, 0, 0, 0, 1]); // <= adresa 17
    system.circuits[1].setContentWord(2, [1, 0, 1, 1, 0, 0, 0, 0]); // INC r0
    system.circuits[1].setContentWord(3, [1, 0, 0, 0, 1, 0, 0, 0]); // STA [18], r0
    system.circuits[1].setContentWord(4, [0, 0, 0, 1, 0, 0, 1, 0]); // <= adresa 18
    system.circuits[1].setContentWord(5, [1, 1, 1, 1, 1, 1, 1, 1]); // HALT
    system.circuits[1].setContentWord(17, [0, 0, 0, 0, 1, 1, 1, 0]); // <= konstanta 14
    let simenv = new dlsimulIncremental(window, engine);

    let cntr1 = new system1vis(
        "myCanvas1", cp, res,
        engine.createDriver("/cp"),
        engine.createDriver("/res"),
        system,
        simenv
    );
    simenv.paintComponents.push(cntr1);

    engine.initSimulation();
    simenv.ping();
    RAMVisualContent("myCanvasRamC", system.circuits[1]);


    function generirajPrikaz() {
        let arr = [];
        for (let i = 0; i < engine.signals.length; i++) {
            arr.push("<li>" + engine.signals[i].name + ", " + dlsimul.std_logic_1164.values[engine.signals[i].value] + "</li>");
        }
        let rez = "<ol>" + arr.join("") + "</ol>";
        document.getElementById("prikaz").innerHTML = rez;
    }


    for (let i = 0; i < 100; i++) {
        if (engine.peekNextTime() == null) break;
        engine.simulateNextStep();
    }
</script>


<ol id="swapSection1">
    <li>
        <h3 class="swapTitle">Resetiranje procesora</h3>
        <p>Prvo što moramo učiniti je resetirati procesor, kako bismo ga doveli u poznato početno stanje
            čime emuliramo postupak uključivanja računala. Lijevo od procesora prikazane su dvije
            zasivljene pločice i vrijednost koju šalju prema procesoru. Kliknite na svaku od njih jednom,
            čime ćete vrijednost postaviti u logičku nulu. Potom pažljivo slijedite naputak u nastavku.
        </p>
    </li>
    <li>
        <h3 class="swapTitle">Resetiranje procesora</h3>
        <ol class="swapSubSection">
            <li>Kliknite jednom na pločicu RESET. Vrijednost će se promijeniti u 1, čime ćete procesoru
                poslati signal za reset. Procesor taj signal ignorira, sve dok na ulazu za signal takta
                ne registrira promjenu signala takta s logičke nule u logičku jedinicu (takozvani rastući
                brid signala takta).
            </li>
            <li>Kliknite sada mišem na pločicu CP (signal takta): vrijednost će se promijeniti iz 0 i 1,
                procesor će primijetiti rastući brid, uočiti da je RESET aktivan i započeti prvi korak
                resetiranja. Vizualno, nećete primijetiti nikakvu promjenu.
            </li>
            <li>Kliknite sada još jednom na CP čime ćete signal takta vratiti u 0, i nakon toga još jednom
                na CP čime ćete u procesor poslati novi rastući brid. Na ovaj rastući brid odradit će se
                drugi korak resetiranja. Sada ćete primijetiti da je sadržaj registara <code>r0</code> do
                <code>r3</code> postao poznat i postavljen je na 0. I ostali signali poprimili su poznate
                vrijednosti, a procesor je ušao u prvi od sedam ciklusa kroz koje prolazi pri dohvatu
                i izvođenju instrukcije (primijetite u simbolu procesora <i>Cycle:</i> T1 (mijenjat će se
                od T1 do T7).
            </li>
            <li>Kliknite ponovno na CP kako biste ga vratili u 0, i kliknite na RESET kako biste i njega
                vratili na 0 (čime deaktiviramo postupak resetiranja i omogućavamo normalan rad procesora).
                Ako zaboravite deaktivirati signal za RESET, ništa lošega se neće dogoditi, jedino što će
                se procesor i dalje neprestano resetirati umjesto da počne izvoditi program.
            </li>
        </ol>
    </li>


    <li>
        <h3 class="swapTitle">Izvođenje programa (naredba <code>LDA r0, [17]</code>)</h3>
        <ol class="swapSubSection">
            <li>Kliknite na CP čime ste ga prebacili u 1; procesor je otišao u ciklus T2. Aktiviran je
                signal RW' (postavljen je na 1 čime je procesor memoriji javio da želi pročitati podatak,
                ali memorija još nije aktivirana (signal CS0 procesor drži na 0).
            </li>
            <li>Kliknite na CP čime ćete signal takta vratiti u 0. Procesor je i dalje u ciklusu T2 i
                sada je aktivirao memoriju (postavio je CS0 na 1). Memorija stoga čita adresu s adresne
                sabirnice (adresa je 0), pa na podatkovnu sabirnicu memorija postavlja podatak koji tamo
                ima zapisan (broj 132, odnosno binarno 10000100) - to je prvi dio prve instrukcije i
                procesor je upravo u fazi njezina dohvata.
            </li>
            <li>Kliknite ponovno na CP. Signal takta prešao je u logičko-1, napravio rastući brid pa je
                procesor podatak s podatkovne sabirnice zapisao u interni registar IR i deaktivirao
                memoriju. Ušli smo u ciklus T3, i procesor analizira pribavljeni podatak kako bi otkrio
                o kojoj se instrukciji radi. Otkriva da se radi o instrukciji <code>LDA r0, [???]</code>
                koja procesoru kaže da je iz memorije potrebno pročitati podatak i smjestiti ga u registar
                <code>r0</code>. Problem je što u ovom trenutku procesor još ne zna s koje adrese: to piše
                u drugom oktetu instrukcije. Primijetite da se adresa sljedeće instrukcije također povećala
                (sada u PC piše 1). Stoga je potrebno pribaviti adresu.
            </li>
            <li>Kliknite na CP čime ste ga vratili na 0. Kliknite ponovno na CP čime ste ga prebacili na
                1; procesor je otišao u ciklus T4, na adresnu sabirnicu postavio je adresu 1 i definirao
                da želi čitanje (RW' je postavio na 1).
            </li>
            <li>Kliknite na CP čime ste ga vratili u 0. Procesor je aktivirao i CS0 čime je aktivirao
                memoriju. Memorija s adrese 1 dohvaća zapisani podatak (broj 17, binarno 00010001 odnosno
                u heksadekadskoj notaciji 11, što je prikazano u memoriji) i postavlja ga na podatkovnu
                sabirnicu.
            </li>
            <li>Kliknite na CP čime ste ga prebacili u 1 i napravili rastući brid. Procesor odlazi u ciklus
                T5 a podatak s podatkovne sabirnice zapisuje u interni registar IRA. Ovo sve možete vidjeti
                na simbolu procesora. Sada procesor zna da se radi o instrukciji
                <code>LDA r0, [17]</code>. Stoga će u nastavku morati iz memorije dohvatiti podatak koji
                je tamo zapisan.
            </li>
            <li>Kliknite na CP čime ste ga prebacili u 0. Kliknite ponovno na CP čime ste ga prebacili u
                1 i napravili rastući brid. Procesor prelazi u ciklus T6 i adresu 17 postavlja na adresnu
                sabirnicu te traži čitanje (ali memoriju još ne aktivira).
            </li>
            <li>Kliknite na CP čime ste ga vratili u 0. Procesor je aktivirao i CS0 i time aktivirao
                memoriju. Memorija s adrese 17 dohvaća zapisani podatak (broj 14, binarno 00001110 odnosno
                u heksadekadskoj notaciji 0E, što je prikazano u memoriji) i postavlja ga na podatkovnu
                sabirnicu.
            </li>
            <li>Kliknite na CP čime ste ga prebacili u 1 i napravili rastući brid. Procesor odlazi u ciklus
                T7 a podatak s podatkovne sabirnice zapisuje u interni registar IRA. Ovo sve možete vidjeti
                na simbolu procesora. Sada procesor zna da podatak koji je dohvatio i pospremio u interni
                registar mora još zapisati u registar <code>r0</code>.
            </li>
            <li>Kliknite na CP čime ste ga vratili u 0. Kliknite ponovno na CP čime ste ga postavili u 1
                i napravili rastući brid signala takta. Procesor je podatak iz internog registra IRA
                zapisao u registar <code>r0</code> i ponovno stigao u ciklus T1 čime je spreman za
                dohvat i izvođenje sljedeće instrukcije. Primijetite u simbolu procesora da je podatak
                stigao u registar <code>r0</code>.<br></li>
        </ol>

    </li>


    <li>
        <h3 class="swapTitle">Izvođenje programa (naredba <code>INC r0</code>)</h3>
        <ol class="swapSubSection">
            <li>Kliknite na CP čime ste ga vratili u 0. Kliknite na CP čime ste ga postavili u 1. Procesor
                prelazi u ciklus T2 a na adresnu sabirnicu postavlja adresu 2. S te adrese želi dohvatiti
                sljedeću instrukciju.
            </li>
            <li>Kliknite na CP čime ćete signal takta vratiti u 0. Procesor je i dalje u ciklusu T2 i
                sada je aktivirao memoriju (postavio je CS0 na 1). Memorija stoga čita adresu s adresne
                sabirnice (adresa je 2), pa na podatkovnu sabirnicu memorija postavlja podatak koji tamo
                ima zapisan (broj 176, odnosno binarno 10110000, B0 heksadekadski) - to je prvi dio druge
                instrukcije i procesor je upravo u fazi njezina dohvata.
            </li>
            <li>Kliknite ponovno na CP. Signal takta prešao je u logičko-1, napravio rastući brid pa je
                procesor podatak s podatkovne sabirnice zapisao u interni registar IR i deaktivirao
                memoriju. Ušli smo u ciklus T3, i procesor analizira pribavljeni podatak kako bi otkrio
                o kojoj se instrukciji radi. Otkriva da se radi o instrukciji <code>INC r0</code>
                koja procesoru kaže da je potrebno uvećati sadržaj registra <code>r0</code>. Ova instrukcija
                veličine je samo jedan oktet, pa daljnja komunikacija s memorijom nije potrebna.
                Primijetite da se adresa sljedeće instrukcije također povećala (sada u PC piše 3).
                Kako je instrukcija pribavljena u cijelosti, procesor podatak iz registra dovodi na
                aritmetičko-logičku jedinicu i konfigurira je tako da računa za jedan veći broj.
            </li>
            <li>Kliknite na CP čime ste ga vratili na 0. Kliknite ponovno na CP čime ste ga prebacili na
                1; procesor je otišao u ciklus T4, a rezultat koji se pojavio na izlazu aritmetičko-logičke
                jedinice pohranio je u registar <code>r0</code> čime je sada u njemu broj 15 (heksadekadski
                0F). Ovime je izvođenje instrukcije gotovo pa su ciklusi T5 do T7 prazni. Kliknite
                potreban broj puta na CP da biste procesor doveli ponovno do novog ciklusa T1. Stanite
                onaj tren kada ste došli u T1 i CP je na 0.<br>
            </li>
        </ol>
    </li>
    <li>
        <h3 class="swapTitle">Izvođenje programa (naredba <code>STA [18], r0</code>)</h3>
        <ol class="swapSubSection">
            <li>Kliknite na CP čime ste ga prebacili u 1; procesor je otišao u ciklus T2. Aktiviran je
                signal RW' (postavljen je na 1 čime je procesor memoriji javio da želi pročitati podatak,
                ali memorija još nije aktivirana (signal CS0 procesor drži na 0). Na adresnu sabirnicu
                procesor je postavio adresu 3.
            </li>
            <li>Kliknite na CP čime ćete signal takta vratiti u 0. Procesor je i dalje u ciklusu T2 i
                sada je aktivirao memoriju (postavio je CS0 na 1). Memorija stoga čita adresu s adresne
                sabirnice (adresa je 3), pa na podatkovnu sabirnicu memorija postavlja podatak koji tamo
                ima zapisan (broj 136, odnosno binarno 10001000) - to je prvi dio treće instrukcije i
                procesor je upravo u fazi njezina dohvata.
            </li>
            <li>Kliknite ponovno na CP. Signal takta prešao je u logičko-1, napravio rastući brid pa je
                procesor podatak s podatkovne sabirnice zapisao u interni registar IR i deaktivirao
                memoriju. Ušli smo u ciklus T3, i procesor analizira pribavljeni podatak kako bi otkrio
                o kojoj se instrukciji radi. Otkriva da se radi o instrukciji <code>STA [???], r0</code>
                koja procesoru kaže da je u memoriju potrebno zapisati podatak koji je trenutno u registru
                <code>r0</code>. Problem je što u ovom trenutku procesor još ne zna na koju adresu: to piše
                u drugom oktetu instrukcije. Primijetite da se adresa sljedeće instrukcije također povećala
                (sada u PC piše 4). Stoga je potrebno pribaviti adresu.
            </li>
            <li>Kliknite na CP čime ste ga vratili na 0. Kliknite ponovno na CP čime ste ga prebacili na
                1; procesor je otišao u ciklus T4, na adresnu sabirnicu postavio je adresu 4 i definirao
                da želi čitanje (RW' je postavio na 1).
            </li>
            <li>Kliknite na CP čime ste ga vratili u 0. Procesor je aktivirao i CS0 čime je aktivirao
                memoriju. Memorija s adrese 4 dohvaća zapisani podatak (broj 18, binarno 00010010 odnosno
                u heksadekadskoj notaciji 12, što je prikazano u memoriji) i postavlja ga na podatkovnu
                sabirnicu.
            </li>
            <li>Kliknite na CP čime ste ga prebacili u 1 i napravili rastući brid. Procesor odlazi u ciklus
                T5 a podatak s podatkovne sabirnice zapisuje u interni registar IRA. Ovo sve možete vidjeti
                na simbolu procesora. Sada procesor zna da se radi o instrukciji
                <code>STA [18], r0</code>. Stoga će u nastavku morati u memoriju zapisati podatak iz
                zadanog registra.
            </li>
            <li>Kliknite na CP čime ste ga prebacili u 0. Kliknite ponovno na CP čime ste ga prebacili u
                1 i napravili rastući brid. Procesor prelazi u ciklus T6 i adresu 18 postavlja na adresnu
                sabirnicu te traži zapisivanje - postavio je RW' na 0 (ali memoriju još ne aktivira).
            </li>
            <li>Kliknite na CP čime ste ga vratili u 0. Procesor je aktivirao i CS0 i time aktivirao
                memoriju. Istovremeno je na podatkovnu sabirnicu postavio broj 15 - podatak koji je bio
                zapisan u registru <code>r0</code>. Memorija stoga na memorijsku lokaciju 18 koja je
                zadana preko adresne sabirnice upisuje podatak koji čita s podatkovne sabirnice.
            </li>
            <li>Kliknite na CP čime ste ga prebacili u 1 i napravili rastući brid. Procesor odlazi u ciklus
                T7 koji je sada prazan - posao je obavljen i tu se više ništa ne događa.
            </li>
            <li>Kliknite na CP čime ste ga vratili u 0. Kliknite ponovno na CP čime ste ga postavili u 1
                i napravili rastući brid signala takta. Procesor je ponovno stigao u ciklus T1 čime je
                spreman za dohvat i izvođenje sljedeće instrukcije.<br>

            </li>
        </ol>
    </li>

    <li>
        <h3 class="swapTitle">Izvođenje programa (naredba <code>HALT</code>)</h3>
        <p>
            Nastavite li dalje, sljedeća instrukcija programa je HALT nakon čijeg će izvođenja procesor
            početi ignorirati impulse signala takta: instrukcija ga je zaustavila i više ga ništa osim
            reseta ne može probuditi.
        </p>
    </li>
</ol>

<hr>
<p>Ako ste uspješno prošli kroz ovaj primjer, vjerojatno su Vam se otvorili novi vidici.
    Sada biste već morali početi dobivati sliku o tome kako se izvodi obrada podataka u jednom
    računalu, na koji (okvirno) način radi jedan procesor, i što se događa kada programirate
    u višim programskim jezicima: sve što napišete, naposljetku se uporabom prikladnog
    jezičnog prevodioca mora svesti na niz ovakvih elementarnih instrukcija koje je centralni
    procesor sposoban izvoditi.</p>

<p>U okviru kolegija Digitalna logika naš će fokus biti <em>na građevnim komponentama</em>
    ovakvih sustava. U priču ćemo krenuti od brojevnih sustava i kodova, potom ćemo se upoznati
    s Booleovom algebrom i osnovnim logičkim sklopovima, nakon čega priču dalje razvijamo kroz
    kombinacijsko i sekvencijsko sklopovlje, analogno/digitalne i digitalno/analogne pretvornike,
    memorije, elektroničke implementacije i programirljivo sklopovlje. Čitavo to vrijeme,
    pokušavat ćemo se, međutim, vraćati na ovdje prikazani primjer i pogledati gdje se u jednoj
    memoriji odnosno procesoru mogu pronaći te komponente, koja im je funkcionalnost te kako ih
    koristimo.</p>

<script>
    /*@#page-include#(sectionSwapper.js)*/
</script>